<template>
  <div class="userInfo">
    <a-card
      :bordered="false"
      :bodyStyle="{ padding: '0px 24px 8px 24px' }"
      :headStyle="{ 'border-bottom': '0px' }"
      title="Contact Info"
    >
      <div>
        <div class="title">
          Email
        </div>
        <div>{{ info.email }}</div>
      </div>
    </a-card>
    <a-divider />
    <a-card
      :bordered="false"
      :bodyStyle="{ padding: '0px 24px 8px 24px' }"
      :headStyle="{ 'border-bottom': '0px' }"
      title="Member Info"
    >
      <div>
        <span class="title">Enabled</span>
        <a-switch
          :loading="loading"
          @change="updateStatus"
          :defaultChecked="info.enabled"
          style="margin-left: 18px; width: 120px"
          checked-children="ENABLED"
          un-checked-children="DISABLED"
        />
      </div>
      <div style="margin-top: 12px">
        <span class="title">Status</span>
        <a-switch
          :loading="loading"
          @change="confirmUser"
          :disabled="info.userStatus === 'CONFIRMED'"
          :defaultChecked="info.userStatus === 'CONFIRMED'"
          style="margin-left: 28px; width: 120px"
          checked-children="CONFIRMED"
          un-checked-children="UNCONFIRMED"
        />
      </div>
    </a-card>

    <a-divider />

    <div style="padding: 0px 8px">
      <a-button
        @click="showConfirmDelete"
        type="danger"
        block
      >
        Delete User
      </a-button>
    </div>
  </div>
</template>

<script>
import { recruiterApi } from '@/api'

export default {
  props: {
    info: {
      type: Object,
      default: () => null
    }
  },
  data () {
    return {
      enabled: true,
      loading: false
    }
  },
  methods: {
    confirmUser () {
      console.log(this.info)
      return recruiterApi
        .confirmUser(this.info.username)
        .then(() => {
          this.$emit('changed', this.info.username)
        })
        .catch((err) => {
          console.log(err)
          this.$message.error(err.message)
        })
    },
    updateStatus (Enabled) {
      return recruiterApi
        .updateUserStatus(this.info.username, Enabled)
        .then(() => {
          this.$emit('changed', this.info.username)
        })
        .catch((err) => {
          console.log(err)
          this.$message.error(err.message)
        })
    },
    showConfirmDelete () {
      const self = this
      this.$confirm({
        title: 'Do you want to delete this user?',
        content:
          "This user will be deleted immediately. You can't undo this action",
        onOk () {
          return recruiterApi
            .deleteUser(self.info.username)
            .then(() => {
              console.log('DELEED')
              self.$emit('changed', self.info.username)
            })
            .catch(() => self.$message.error('Oops errors!'))
        },
        onCancel () {}
      })
    }
  }
}
</script>

<style lang="less">
.userInfo {
  .title {
    font-size: 14px;
    font-weight: bold;
  }
}
</style>
